package lols.core.client.android

import org.springframework.web.client.RestTemplate
import java.net.URL
import scalapi.lang.Implicits._
import java.util.Collections
import lols.core.common.{MethodCall, MethodCallSerializer}

class RestTemplateMethodCallSerializer(restTemplate: RestTemplate, serviceLocation: URL)
  extends MethodCallSerializer {

  restTemplate.assertNotNull()
  serviceLocation.assertNotNull()

  restTemplate.setMessageConverters(Collections.singletonList(new XStreamHttpMessageConverter()))

  def serializeCall(methodCall: MethodCall): AnyRef = {
    try {
      val methodCalled = Class.forName(methodCall.targetClass).getMethods.filter(_.getName == methodCall.methodName)(0)
      return restTemplate.postForObject(serviceLocation.toString, methodCall, methodCalled.getReturnType).asInstanceOf[AnyRef]
    }
    catch {
      case e: ClassNotFoundException => {
        throw new RuntimeException(e)
      }
    }
  }

}